=== debian/changelog ===
iem-plugin-suite (1.13.0-2) unstable; urgency=medium

  * Provide virtual package "vst-plugin"
  * Rebuild against juce-6.1.5

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 08 Feb 2022 19:52:10 +0100

iem-plugin-suite (1.13.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 23 Dec 2021 13:00:48 +0100

iem-plugin-suite (1.13.0-1~exp1) experimental; urgency=medium

  * New upstream version 1.13.0
    * Drop patch applied upstream
    * Backport upstream fixes
  * Use CMake instead of Projucer to build
    * Don't build VST3
  * Drop "Files-Excluded: .git*" from d/copyright
  * Apply 'wrap-and-sort -ast'
  * d/copyright: Trimmed away unused licenses
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 17 Dec 2021 10:21:54 +0100

iem-plugin-suite (1.12.0-1~exp1) experimental; urgency=medium

  * New upstream version 1.12.0
  * Adjust for JUCE-6.1.0
  * Refresh d/copyright
    * Regenerate d/copyright_hints
  * Bump dh-compat to 13
    * Don't manually create symlinks (use *.links for that)
  * Bump standards version to 4.5.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 30 Aug 2021 15:15:58 +0200
